Attribute VB_Name = "Servarena"
Public Type MapRecord
    Name As String * 30
    filename As String * 20
    FragLimit As String * 3
    TimeLimit As String * 3
    CaptureLimit As String * 3
    Gravity As String * 4
    Speed As String * 4
    KnockBack As String * 4
End Type

Global Map As MapRecord

Global MapError As Boolean
Global chPath As Boolean

Global chQ3Path As Boolean
Global LastMap As Integer
Global Q3Path As String
Global Q3Exe As String
Global gotConfig As Boolean
Global BotTeam(0 To 99) As Integer
Global BotSkill(0 To 99) As Integer
Global Loading As Boolean
Global URL As String
Global eMail As String
Global EditMapNum As Integer

' used to set defaults for new maps
Global dfTimeLimit, dfFragLimit, dfSpeed, dfGravity, dfCaptureLimit, dfKnockBack As String

Public Declare Function ShellExecute Lib _
    "shell32.dll" Alias "ShellExecuteA" _
    (ByVal hwnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long
Public Const SW_SHOWNORMAL = 1

' added for the support of TGA graphics

Declare Function Load_JPG Lib "NViewLib.dll" (ByVal filename As String, ByVal a As Integer) As Long
Declare Function Load_GIF Lib "NViewLib.dll" (ByVal filename As String, ByVal a As Integer) As Long
Declare Function NViewLibLoad Lib "NViewLib.dll" (ByVal filename As String, ByVal a As Integer) As Long
Declare Function NViewLibSaveAsJPG Lib "NViewLib.dll" (ByVal Quality As Integer, ByVal filename As String) As Integer
Declare Function NViewLibSetLanguage Lib "NViewLib.dll" (ByVal Language As String) As Integer
Declare Sub NViewLibSetCustomLang Lib "NViewLib.dll" (ByVal pProgress As String, ByVal pError As String, ByVal pLoad As String, ByVal pErrLoad As String, ByVal pWarning As String)
Declare Function GetWidth Lib "NViewLib.dll" () As Integer
Declare Function GetHeight Lib "NViewLib.dll" () As Integer

Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long



Function TotalMaps() As Integer
    Dim X As Integer
    Open App.Path + "\maps.dat" For Random As #8 Len = Len(Map)
    X = 1
    Do
        Get #8, X, Map
        If EOF(8) Then
            TotalMaps = X - 1
            Exit Do
        End If
        X = X + 1
    Loop
    Close #8
    
End Function

Function FindMap(ByVal mName As String) As Integer
    Dim MapNumber, N As Integer
    MapNumber = -1
    Dim Tm As Integer
    Tm = TotalMaps
    
    Open App.Path + "\maps.dat" For Random As #8 Len = Len(Map)
    
    If Tm > 0 Then
        For N = 1 To Tm
            Get #8, N, Map
            If LCase(Trim(mName)) = LCase(Trim(Map.filename)) Then
                MapNumber = N
                Exit For
            End If
        Next N
    End If
    
    Close #8

    FindMap = MapNumber
    
End Function

Function Exists(ByVal fn As String) As Boolean
    On Error GoTo noEx
    Exists = False
    Open fn For Input As #7
    Close #7
    Exists = True
Done:
    Exit Function
noEx:
    Resume Done
End Function


Function RevSet(curSet As Variant) As Variant
    If curSet = 1 Then
        RevSet = 0
    Else
        RevSet = 1
    End If
End Function

Sub GetRegistryKeys()
    
    On Error GoTo CaptureError
    
    Dim eMsg As String
    
    Dim tmpInt As Integer
    Dim tmpBool As Boolean
    Dim N As Integer
    
    With frmMain
        
    eMsg = "Error setting status bar visibility"
    ' PROGRAM OPTIONS
    ' ---------------------------------------------------------------
    tmpBool = GetSetting(App.EXEName, "Settings", "StatusBar", True)
    If tmpBool = True Then
        frmMain.RollOut
    Else
        frmMain.Rollin
    End If
    
    eMsg = "Error setting last tab"
    tmpInt = GetSetting(App.EXEName, "Settings", "LastTab", 0)
    If tmpInt = 6 Then tmpInt = 0
    .SSTab1.Tab = tmpInt
    
    
    
    
    ' GENERAL TAB
    ' ---------------------------------------------------------------
    eMsg = "Error setting server name"
    .txtServerName.Text = GetSetting(App.EXEName, "General", "Name", "My Quake 3 Arena Server")
    eMsg = "Error setting MOTD"
    .txtMOTD.Text = GetSetting(App.EXEName, "General", "Motd", "Configured with Servarena")
    eMsg = "Error setting Server password"
    .txtServerPW.Text = GetSetting(App.EXEName, "General", "Password", "")
    eMsg = "Error setting console password"
    .txtConsolePW.Text = GetSetting(App.EXEName, "General", "RconPassword", "")
    tmpInt = GetSetting(App.EXEName, "General", "GameType", 0)
    
    eMsg = "Error setting Game Type to " + Str(tmpInt)
    If tmpInt = 4 Then
        .cmbGameType.ListIndex = 3
    Else
        .cmbGameType.ListIndex = tmpInt
    End If

    eMsg = "Error setting Admin Properties"
    .txtAdminName.Text = GetSetting(App.EXEName, "General", "AdminName", "")
    .txtAdminEmail.Text = GetSetting(App.EXEName, "General", "AdminEmail", "")
    .txtAdminURL.Text = GetSetting(App.EXEName, "General", "AdminURL", "")


    ' BOTS TAB
    ' ---------------------------------------------------------------
    
    eMsg = "Error setting Bot Properties"
    .cmbBotType.ListIndex = GetSetting(App.EXEName, "Bots", "Enabled", 0)
    .cmbBotSkill.ListIndex = GetSetting(App.EXEName, "Bots", "Skill", 3)
    .chkDisableBotChat.Value = GetSetting(App.EXEName, "Bots", "DisableChat", 0)
    .chkRocketJump.Value = GetSetting(App.EXEName, "Bots", "RocketJump", 1)
    .chkNoBotJump.Value = GetSetting(App.EXEName, "Bots", "NoBotJumps", 0)
    ' step through the registry to select each bot:
    
    For N = 0 To .BotList.ListCount - 1
        tmpBool = GetSetting(App.EXEName, "Bots", "Selected" + Trim(Str(N)), False)
        .BotList.Selected(N) = tmpBool
        BotTeam(N) = GetSetting(App.EXEName, "Bots", "Team " + Trim(Str(N)), 0)
        BotSkill(N) = GetSetting(App.EXEName, "Bots", "Strength " + Trim(Str(N)), 1)
    Next N
    
    eMsg = "Error setting auto selected bots"
    .chkAutoSelectBots = GetSetting(App.EXEName, "Bots", "AutoSelBots", 0)
    .txtRandomBots.Text = GetSetting(App.EXEName, "Bots", "RandomBotNum", "")

    SetAutoSelectBots
    
    eMsg = "Error setting autobot information"
    
    .cmbAutoBotSkill.ListIndex = GetSetting(App.EXEName, "Bots", "AutoBotSkill", 3)
    .txtMinBots.Text = GetSetting(App.EXEName, "Bots", "AutoBotCount", "2")
    .chkRandomBotSkill = GetSetting(App.EXEName, "Bots", "RandomSkill", 0)
    
    SetBotSkill
    SetBotControls
    
    ' LIMITS TAB
    ' ---------------------------------------------------------------
    eMsg = "Error setting Max Players"
    .txtMaxPlayers.Text = GetSetting(App.EXEName, "Limits", "MaxPlayers", "6")
    eMsg = "Error setting Player respawn value"
    .txtPlayerRespawn.Text = GetSetting(App.EXEName, "Limits", "PlayerRespawn", "10")
    eMsg = "Error setting Inactivity timeout"
    .txtInactivity.Text = GetSetting(App.EXEName, "Limits", "InactivityTimeout", "180")

    ' OPTIONS TAB
    ' ---------------------------------------------------------------
    eMsg = "Error setting Quad damage"
    .txtQuad.Text = GetSetting(App.EXEName, "Options", "QuadMultiplier", "3")
    eMsg = "Error setting weapon respawn"
    .txtRespawn.Text = GetSetting(App.EXEName, "Options", "WeaponRespawn", "5")
    eMsg = "Error setting Vote checkbox"
    .chkVote.Value = GetSetting(App.EXEName, "Options", "AllowVoting", 0)
    eMsg = "Error setting Synch clients"
    .chkDemoRecording.Value = GetSetting(App.EXEName, "Options", "AllowDemoRecording", 0)
    eMsg = "Error setting server type value"
    .cmbServerType.ListIndex = GetSetting(App.EXEName, "Options", "ServerType", 2)
    eMsg = "Error setting devmap value"
    .chkCheating.Value = GetSetting(App.EXEName, "Options", "EnableCheats", 0)
    eMsg = "Error setting pure server"
    .chkPAKCheat.Value = GetSetting(App.EXEName, "Options", "CheckClientPAKs", 1)
    eMsg = "Error setting Friendly fire"
    .chkFriendly.Value = GetSetting(App.EXEName, "Options", "FridnlyFire", 0)
    eMsg = "Error setting Startup state"
    .chkStartState.Value = GetSetting(App.EXEName, "Options", "StartState", 0)
    eMsg = "Error setting Shutdown options"
    .optClose.Value = GetSetting(App.EXEName, "Options", "StartClose", 0)
    .optMinimize.Value = GetSetting(App.EXEName, "Options", "StartMin", 1)
    
    SetStartState
    
    eMsg = "Error setting auto-join/auto-balance"
    .chkAutoJoin.Value = GetSetting(App.EXEName, "Options", "AutoJoin", 1)
    .chkAutoBalance.Value = GetSetting(App.EXEName, "Options", "AutoBalance", 1)
    
    eMsg = "Error setting Master servers"
    .txtMaster(0).Text = GetSetting(App.EXEName, "Options", "Master0", "master3.idsoftware.com")
    .txtMaster(1).Text = GetSetting(App.EXEName, "Options", "Master1", "master0.gamespy.com")
    
    For N = 2 To 4
        .txtMaster(N).Text = GetSetting(App.EXEName, "Options", "Master" + Trim(Str(N)), "")
    Next N

    .chkWarmUp.Value = GetSetting(App.EXEName, "Options", "WarmUp", 0)
    .txtWarmUpTime.Text = GetSetting(App.EXEName, "Options", "WarmUpTime", "20")
    SetWarmUp


    ' ADVANCED TAB
    ' ---------------------------------------------------------------
    eMsg = "Error setting memory allocation"
    .txtHunkMegs.Text = GetSetting(App.EXEName, "Network", "HunkMegs", "16")
    eMsg = "Error setting net IP"
    .txtNetIP.Text = GetSetting(App.EXEName, "Network", "NetIP", "")
    eMsg = "Error setting net port"
    .txtNetPort.Text = GetSetting(App.EXEName, "Network", "NetPort", "")
    eMsg = "Error setting Max rate"
    .txtMaxRate.Text = GetSetting(App.EXEName, "Network", "MaxRate", "10000")
    eMsg = "Error setting parameters"
    
    SetCmdParameters
    
    eMsg = "Error setting NOP status"
    .chkNOP.Value = GetSetting(App.EXEName, "Advanced", "NOP", 0)
    eMsg = "Error setting CD properties"
    .chkSpecifyCD.Value = GetSetting(App.EXEName, "Advanced", "SpecifyCD", 0)
    eMsg = "Error setting password requirements"
    .chkRequirePassword.Value = GetSetting(App.EXEName, "Advanced", "RequirePW", 0)
    eMsg = "Error setting private clients"
    .txtPrivateClients.Text = GetSetting(App.EXEName, "Advanced", "PrivateClients", "0")
    eMsg = "Error setting min/max ping"
    .txtMinPing.Text = GetSetting(App.EXEName, "Advanced", "MinPing", "0")
    .txtMaxPing.Text = GetSetting(App.EXEName, "Advanced", "MaxPing", "0")
    eMsg = "Error setting log filename information"
    .chkLogFile.Value = GetSetting(App.EXEName, "Advanced", "SpecifyLog", "0")
    .chkDateLog.Value = GetSetting(App.EXEName, "Advanced", "DateCodeLog", "0")
    .txtLogFile.Text = GetSetting(App.EXEName, "Advanced", "LogName", "")
    SetLogInfo
    eMsg = "Error setting warm up time information"
    SetCDRomDrive
    SetPWFields
    
    End With

Done:
    Exit Sub


CaptureError:
    If eMsg > "" Then
        MsgBox eMsg + vbCr + vbCr + "You may continue, but please notify Snow Dog of this error.", vbInformation, "Error"
    Else
        MsgBox "An error has occured while assigning values to the controls - Please report this to Snow Dog", vbInformation, "Warning"
    End If
    Resume Next
    

End Sub


Sub SaveRegistryKeys()

    Dim tmpInt As Integer
    Dim tmpBool As Boolean
    Dim N As Integer
    
    With frmMain
    
'    SaveSetting App.EXEName, "Settings", "CheckNewMaps", .mnuSettingsMapCheck.Checked
    
    ' PROGRAM OPTIONS
    ' ---------------------------------------------------------------
    If .Height < 5515 Then
        SaveSetting App.EXEName, "Settings", "StatusBar", False
    Else
        SaveSetting App.EXEName, "Settings", "StatusBar", True
    End If
    
    SaveSetting App.EXEName, "Settings", "LastTab", .SSTab1.Tab
    
    ' GENERAL TAB
    ' ---------------------------------------------------------------
    SaveSetting App.EXEName, "General", "Name", .txtServerName.Text
    SaveSetting App.EXEName, "General", "Motd", .txtMOTD.Text
    SaveSetting App.EXEName, "General", "Password", .txtServerPW.Text
    SaveSetting App.EXEName, "General", "RconPassword", .txtConsolePW.Text
    
    SaveSetting App.EXEName, "General", "GameType", .cmbGameType.ListIndex
    SaveSetting App.EXEName, "General", "AdminName", .txtAdminName.Text
    SaveSetting App.EXEName, "General", "AdminEmail", .txtAdminEmail.Text
    SaveSetting App.EXEName, "General", "AdminURL", .txtAdminURL.Text
    
    ' BOTS TAB
    ' ---------------------------------------------------------------
    SaveSetting App.EXEName, "Bots", "Enabled", .cmbBotType.ListIndex
    SaveSetting App.EXEName, "Bots", "Skill", .cmbBotSkill.ListIndex
    SaveSetting App.EXEName, "Bots", "DisableChat", .chkDisableBotChat.Value
    SaveSetting App.EXEName, "Bots", "RocketJump", .chkRocketJump.Value
    SaveSetting App.EXEName, "Bots", "NoBotJumps", .chkNoBotJump.Value
    SaveSetting App.EXEName, "Bots", "AutoBotSkill", .cmbAutoBotSkill.ListIndex
    SaveSetting App.EXEName, "Bots", "AutoBotCount", .txtMinBots.Text
    SaveSetting App.EXEName, "Bots", "RandomSkill", .chkRandomBotSkill
    
    ' step through the registry to select each bot:
    
    For N = 0 To .BotList.ListCount - 1
        SaveSetting App.EXEName, "Bots", "Selected" + Trim(Str(N)), .BotList.Selected(N)
        SaveSetting App.EXEName, "Bots", "Team " + Trim(Str(N)), BotTeam(N)
        SaveSetting App.EXEName, "Bots", "Strength " + Trim(Str(N)), BotSkill(N)
    Next N
    
    SaveSetting App.EXEName, "Bots", "AutoSelBots", .chkAutoSelectBots
    SaveSetting App.EXEName, "Bots", "RandomBotNum", .txtRandomBots.Text

    ' LIMITS TAB
    ' ---------------------------------------------------------------
    SaveSetting App.EXEName, "Limits", "MaxPlayers", .txtMaxPlayers.Text
    SaveSetting App.EXEName, "Limits", "PlayerRespawn", .txtPlayerRespawn.Text
    SaveSetting App.EXEName, "Limits", "InactivityTimeout", .txtInactivity.Text

    ' OPTIONS TAB
    ' ---------------------------------------------------------------
    SaveSetting App.EXEName, "Options", "QuadMultiplier", .txtQuad.Text
    SaveSetting App.EXEName, "Options", "WeaponRespawn", .txtRespawn.Text
    SaveSetting App.EXEName, "Options", "AllowVoting", .chkVote.Value
    SaveSetting App.EXEName, "Options", "AllowDemoRecording", .chkDemoRecording.Value
    SaveSetting App.EXEName, "Options", "ServerType", .cmbServerType.ListIndex
    SaveSetting App.EXEName, "Options", "EnableCheats", .chkCheating.Value
    SaveSetting App.EXEName, "Options", "CheckClientPAKs", .chkPAKCheat.Value
    SaveSetting App.EXEName, "Options", "FriendlyFire", .chkFriendly.Value
    SaveSetting App.EXEName, "Options", "StartState", .chkStartState.Value
    SaveSetting App.EXEName, "Options", "StartClose", .optClose.Value
    SaveSetting App.EXEName, "Options", "StartMin", .optMinimize.Value
    SaveSetting App.EXEName, "Options", "AutoJoin", .chkAutoJoin.Value
    SaveSetting App.EXEName, "Options", "AutoBalance", .chkAutoBalance.Value
    SaveSetting App.EXEName, "Options", "WarmUp", .chkWarmUp.Value
    SaveSetting App.EXEName, "Options", "WarmUpTime", .txtWarmUpTime.Text
    

    For N = 0 To 4
        SaveSetting App.EXEName, "Options", "Master" + Trim(Str(N)), .txtMaster(N).Text
    Next N

    

    ' ADVANCED TAB
    ' ---------------------------------------------------------------
    SaveSetting App.EXEName, "Network", "HunkMegs", .txtHunkMegs.Text
    SaveSetting App.EXEName, "Network", "NetIP", .txtNetIP.Text
    SaveSetting App.EXEName, "Network", "NetPort", .txtNetPort.Text
    SaveSetting App.EXEName, "Network", "MaxRate", .txtMaxRate.Text
    SaveSetting App.EXEName, "Network", "Config", .txtCfg.Text
    SaveSetting App.EXEName, "Advanced", "CDLine", .txtCmdParameters
    SaveSetting App.EXEName, "Advanced", "NOP", .chkNOP.Value
    SaveSetting App.EXEName, "Advanced", "SpecifyCD", .chkSpecifyCD.Value
    SaveSetting App.EXEName, "Advanced", "CDLetter", .txtCDROM.Text
    SaveSetting App.EXEName, "Advanced", "RequirePW", .chkRequirePassword.Value
    SaveSetting App.EXEName, "Advanced", "PrivateClients", .txtPrivateClients.Text
    SaveSetting App.EXEName, "Advanced", "MinPing", .txtMinPing.Text
    SaveSetting App.EXEName, "Advanced", "MaxPing", .txtMaxPing.Text
    SaveSetting App.EXEName, "Advanced", "SpecifyLog", .chkLogFile.Value
    SaveSetting App.EXEName, "Advanced", "DateCodeLog", .chkDateLog.Value
    SaveSetting App.EXEName, "Advanced", "LogName", .txtLogFile.Text
    End With

End Sub

Sub SetWarmUp()
    With frmMain
    If .chkWarmUp.Value = 1 Then
        .txtWarmUpTime.Enabled = True
    Else
        .txtWarmUpTime.Enabled = False
    End If
    End With
End Sub

Sub SetLogInfo()
    With frmMain
        If .chkLogFile.Value = 1 Then
            .Frame11.Enabled = True
            .txtLogFile.Enabled = True
            .chkDateLog.Enabled = True
        Else
            .Frame11.Enabled = False
            .txtLogFile.Enabled = False
            .chkDateLog.Enabled = False
        End If
        If .chkDateLog.Value = 1 Then
            .txtLogFile.Enabled = False
        Else
            If .chkLogFile.Value = 1 Then
                .txtLogFile.Enabled = True
            End If
        End If
    End With
End Sub

Sub SetBotControls()
    With frmMain
    Select Case .cmbBotType.ListIndex
    Case 0 ' disable
        .BotList.Enabled = False
        .cmbBotSkill.Enabled = False
        .cmbBotTeam.Enabled = False
        .Label16.Enabled = False
        .Label24.Enabled = False
        .lblBotCount.Enabled = False
        .picManualBots.Enabled = False
        .picAutoBots.Enabled = False
        .Label33.Enabled = False
        .Label34.Enabled = False
        .cmbAutoBotSkill.Enabled = False
        .txtMinBots.Enabled = False
        .chkDisableBotChat.Enabled = False
        .chkAutoSelectBots.Enabled = False
        .Label31.Enabled = False
        .txtRandomBots.Enabled = False
    
    Case 1 ' manual
        .picManualBots.ZOrder 0
        .picManualBots.Enabled = True
        .BotList.Enabled = True
        .cmbBotSkill.Enabled = True
        .cmbBotTeam.Enabled = True
        .Label16.Enabled = True
        .Label24.Enabled = True
        .lblBotCount.Enabled = True
        .chkDisableBotChat.Enabled = True
    Case 2 ' auto
        .picAutoBots.ZOrder 0
        .picAutoBots.Enabled = True
        .Label33.Enabled = True
        .Label34.Enabled = True
        .cmbAutoBotSkill.Enabled = True
        .txtMinBots.Enabled = True
        .chkDisableBotChat.Enabled = True
        
        .chkAutoSelectBots.Enabled = False
        .Label31.Enabled = False
        .txtRandomBots.Enabled = False
    
    End Select
    End With
    SetBotSkill
    SetAutoSelectBots
    
End Sub

Sub SetStartState()
    With frmMain
        If .chkStartState.Value = 1 Then
            .optClose.Enabled = True
            .optMinimize.Enabled = True
        Else
            .optClose.Enabled = False
            .optMinimize.Enabled = False
        End If
    End With
End Sub

Public Sub SetPWFields()
    With frmMain
    If .chkRequirePassword.Value = 1 Then
        .txtServerPW.Enabled = True
        .txtPrivateClients.Enabled = True
        .lblPrivateClients.Enabled = True
    Else
        .txtServerPW.Enabled = False
        .txtPrivateClients.Enabled = False
        .lblPrivateClients.Enabled = False
    End If
    End With
End Sub

Public Sub GetAllSettings(ByVal iniFileName As String)
    Open iniFileName For Input As #5
    Dim rLine As String
    Do
        Line Input #5, rLine
        Select Case rLine
        Case "[General]"
            GetGroupSettings 0
        Case "[Bots]"
            GetGroupSettings 1
        Case "[Maps]"
            GetGroupSettings 2
        Case "[Options]"
            GetGroupSettings 3
        Case "[Advanced]"
            GetGroupSettings 4
        End Select
    Loop Until EOF(5)
    Close #5
End Sub

Public Sub GetGroupSettings(ByVal GroupNum As Byte)
    Dim iLine As String
    Dim eLoc As Long
    Dim iKey As String
    Dim iVal As Variant
    Do
        Line Input #5, iLine
        If iLine = "" Then
            Exit Do
        End If
        eLoc = InStr(1, iLine, "=")
        iKey = Left(iLine, eLoc)
        iVal = Right(iLine, Len(iLine) - eLoc)
        Select Case GroupNum
        Case 0 ' general
            Select Case iKey
            Case "ServerName"
            Case "Motd"
            Case "ServerType"
            Case "GameType"
            Case "AdminName"
            Case "AdminEmail"
            Case "AdminURL"
            Case "MaxPlayers"
            Case "InactivityTimeout"
            Case "ForceRespawn"
            End Select
        Case 1 ' bots
            Select Case iKey
            Case "BotType"
            Case "DisableChat"
            Case "AutoBotSkill"
            Case "AutoBotNumbers"
            
        Case 2 ' maps
        Case 3 ' options
        Case 4 ' advanced
        End Select
    End Select
    Loop
End Sub

Sub SetCDRomDrive()
    On Error GoTo ncd
    Dim N As Integer
    
    Dim Cdr As String
    
    frmMain.txtCDROM.Enabled = True
    Cdr = GetSetting(App.EXEName, "Advanced", "CDLetter", "")
    
    frmMain.txtCDROM.Refresh
    frmMain.txtCDROM.Text = ""
    
    If Cdr > "" Then
        frmMain.txtCDROM.Text = Cdr
    End If
    
Done:
    
    If frmMain.chkSpecifyCD.Value = 1 Then
        frmMain.txtCDROM.Enabled = True
    Else
        frmMain.txtCDROM.Enabled = False
    End If
    
    Exit Sub

ncd:
    frmMain.txtCDROM.Text = ""
    MsgBox "Servarena was unable to locate a valid CD Rom drive." + vbCr + vbCr + "The C: Drive has been selected by default.", vbCritical, "Warning!"
    Resume Done
    
End Sub

Sub SetBotSkill()
'    With frmMain
'    If .chkRandomBotSkill.Value = 1 Then
'        .Label16.Enabled = False
'        .cmbBotSkill.Enabled = True
'    Else
'        .Label16.Enabled = True
'        .cmbBotSkill.Enabled = True
'    End If
'    End With
End Sub

Sub SetCmdParameters()

    frmMain.txtCmdParameters.Clear
    Dim N As Integer
    Dim tCmd As String
    
    For N = 0 To 9
        tCmd = GetSetting(App.EXEName, "Advanced", "Parameter" + Trim(Str(N)), "")
        If tCmd > "" Then frmMain.txtCmdParameters.AddItem tCmd
    Next N
    
    frmMain.txtCmdParameters.Text = GetSetting(App.EXEName, "Advanced", "CDLine", "")

End Sub

Sub SaveCmdParameters()
    
    
    
    Dim N, t As Integer
    Dim tCmd As String
    Dim cText As String
    
    ' first check to see if the current text is listed
    
    With frmMain
    cText = .txtCmdParameters.Text
    
    If Trim(cText) = "" Then
        SaveSetting App.EXEName, "Advanced", "CDLine", frmMain.txtCmdParameters.Text
        Exit Sub
    End If
    
    t = -1
    
    For N = 0 To 9
        tCmd = GetSetting(App.EXEName, "Advanced", "Parameter" + Trim(Str(N)), "")
        If tCmd = cText Then
            t = N
            Exit For
        End If
    Next N
    
    SaveSetting App.EXEName, "Advanced", "CDLine", frmMain.txtCmdParameters.Text
    
    If t > -1 Then
        Exit Sub
    End If
   
    For N = .txtCmdParameters.ListCount - 1 To 0 Step -1
        tCmd = .txtCmdParameters.List(N)
        SaveSetting App.EXEName, "Advanced", "Parameter" + Trim(Str(N + 1)), tCmd
    Next N
    
    SaveSetting App.EXEName, "Advanced", "Parameter0", cText
    
    End With
    
End Sub

Sub SetAutoSelectBots()

    With frmMain
    If .cmbBotType.ListIndex = 1 Then
        .chkAutoSelectBots.Enabled = True
        If .chkAutoSelectBots.Value = 1 Then
            .txtRandomBots.Enabled = True
            .Label31.Enabled = True
            .BotList.Enabled = True
        Else
            .txtRandomBots.Enabled = False
            .Label31.Enabled = False
            .BotList.Enabled = True
        End If
    Else
        .chkAutoSelectBots.Enabled = False
        .txtRandomBots.Enabled = False
        .Label31.Enabled = False
        .BotList.Enabled = True
    End If
    
    End With
End Sub

Sub WaitASecond()
    Dim D
    Dim N
    For N = 0 To 10000
        D = DoEvents
    Next N
End Sub
